var MeetingList = {
	op : {
		/**
		 * 删除会议纪要
		 * @method del
		 * @param  {Object} param 传入JSON格式数据
		 * @return {Object}       返回deffered对象
		 */
		del : function(param){
			var url = Ibos.app.url('meeting/minutes/del');
			return $.post(url, param, $.noop, 'json'); 
		}
	}
};

$(function(){
	Ibos.evt.add({
		// 导出会议纪要
		"exportMinutes": function(param, elem){
			var ids = U.getCheckedValue("minutes[]");
			if(ids){
				window.location.href = Ibos.app.url('meeting/minutes/export', {ids: ids});
			}else{
				Ui.tip(Ibos.l("MEETING.SELECT_LAST_ONE"), "warning");
			}	

		},
		// 删除会议纪要
		"delMinutes":function(param, elem){
			var ids = U.getCheckedValue("minutes[]");
			param = { ids: ids };
			if(ids){
				Ui.confirm(Ibos.l("MEETING.DELETE_SELECT_CONFIRM"), function(){
					MeetingList.op.del(param).done(function(res){
						if(res.isSuccess){
							Ui.tip(res.msg);
							window.location.reload();
						}else{
							Ui.tip(Ibos.l("DELETE_FAILED"), "danger");
						}
					});
				});
			}else{
				Ui.tip(Ibos.l("MEETING.SELECT_LAST_ONE"), "warning");
			}
		},
		// 删除会议纪要
		"removeMinutes": function(param, elem) {
			var $tr = $(this).closest("tr");
			Ui.confirm(Ibos.l("MEETING.DELETE_PROJECT_CONFIRM"), function(){
				MeetingList.op.del(param).done(function(res) {
					if (res.isSuccess) {
						$tr.remove();
						Ui.tip(res.msg);
						window.location.reload();
					}else{
						Ui.tip(Ibos.l("DELETE_FAILED"), "danger");
					}
				});
			});
		}
	});
});
