(function() {
	var Progressbar = function(elem, options) {
		var style = "progress";
		this.$elem = $(elem);

		options.stripe && (style += " progress-striped");
		options.active && (style += " active");
		this.$bar = $('<div class="progress-bar"></div>');
		this.val(options.value);
		this.$elem.addClass(style).html(this.$bar);
	};

	Progressbar.prototype = {
		constructor: Progressbar,
		val: function(value) {
			if (typeof value === "undefined") {
				return this.value || 0;
			} else {
				value = +value;
				this.value = isNaN(value) ? this.value : value;
				if (!isNaN(this.value)) {
					this.$bar.css("width", this.value + "%");
				}
			}
		}
	};

	$.fn.progressbar = function(options) {
		var ret, argu = Array.prototype.slice.call(arguments, 1);
		this.each(function() {
			var $elem = $(this), data = $elem.data("progressbar");
			if (!data) {
				$elem.data("progressbar", data = new Progressbar(this, $.extend({}, $.fn.progressbar.defaults, options)));
			}
			if (typeof options === "string" && data[options]) {
				ret = data[options].apply(data, argu);
			}
		});
		return typeof ret !== "undefined" ? ret : this;
	};
	$.fn.progressbar.defaults = {
		stripe: true,
		active: true,
		value: 0
	};
	$.fn.progressbar.Constructor = Progressbar;
})();

// 图片上传
(function() {
	var $picBox = $('[data-node-type="picBox"]');
	var _uploadStart = function(file) {
		// 移除上张图片预览
		$picBox.find(".wb-upload-preview").remove();
		// showModal
		$('<div class="wb-upload-modal" data-node-type="uploadModal"></div>')
				.appendTo($picBox).fadeTo(1000, 0.5);
		// showProgress
		$('<div class="wb-upload-progress" data-node-type="uploadProgress"><div data-node-type="uploadProgressbar"></div> <span>上传中 <em data-node-type="uploadPercent">0%</em></span></div>')
				.appendTo($picBox)
				.find('[data-node-type="progressbar"]').progressbar();
	};
	var _uploadProgress = function(file, uploaded, total) {
		var $progressbar = $picBox.find('[data-node-type="uploadProgressbar"]'),
				$percent = $picBox.find('[data-node-type="uploadPercent"]'),
				percent = Math.floor(uploaded / total * 100);
		// updateProgress
		$progressbar.progressbar("val", percent);
		$percent.html(percent + "%");
	};
	var _uploadSuccess = function(file, res) {
		var $tip = $picBox.find('.wb-upload-success-tip'), resData = $.parseJSON(res);
		// hideProgress
		$picBox.find('[data-node-type="uploadProgress"]').remove();
		// tip
		$tip.fadeIn();
		// hideTip, hideModal
		$tip.fadeOut();
		$picBox.find('[data-node-type="uploadModal"]').fadeOut(function() {
			$(this).remove();
		});
		// showPreview
		var html = 	'<div class="wb-upload-preview">'+
						'<img src="<%= attachUrl %>" title="<%= attachName %>" alt="<%= attachName %>">' +
						'<div class="wb-reupload-modal"></div>' +
						'<div class="wb-upload-pic">'+
							'<i class="pic-holder active"></i> '+
							'<p>'+ Ibos.l("MEETING.AGAIN_UPLOAD") +'</p>'+
						'</div>' +
						'<div class="wb-reupload-bar"> '+
							'<div class="wb-reupload-bar-bg rdb"></div> '+
							'<span>"<%= attachName %>"</span> '+
							'<a href="javascript:;" data-action="removePic" class="cbtn o-trash"></a> '+
						'</div>' +
					'</div>';

		$picBox.addClass("wb-upload-success");
		$.tmpl(html, {
			attachUrl: resData.url,
			attachName: resData.name
		}).hide().appendTo($picBox).fadeIn(1000);
		// setValue
		$picBox.find('[data-node-type="picId"]').val(resData.aid);
	};

	Ibos.evt.add({
		"removePic": function() {
			$picBox.find(".wb-upload-preview").remove();
			$picBox.removeClass("wb-upload-success").find('[data-node-type="picId"]').val("");
			$picBox.find(".wb-upload-holder").show();
		}
	});

	Ibos.upload.image({
		button_placeholder_id: "wb_imgupload",
		post_params: {module: 'meeting'},
		file_upload_limit: 0,
		file_queue_limit: 1,
		button_image_url: "",
		button_width: 232,
		button_height: 185,
		button_action:SWFUpload.BUTTON_ACTION.SELECT_FILE,
		file_queued_handler: null,
		upload_start_handler: _uploadStart,
		upload_progress_handler: _uploadProgress,
		upload_success_handler: _uploadSuccess
	});
})();

$(function(){
	$.formValidator.initConfig({
		formID: "meeting_room_form",
		errorFocus: true
	});

	$("#meeting_name").formValidator()
	.regexValidator({
		regExp: "notempty",
		dataType: "enum",
		onError: Ibos.l("MEETING.MEETING_NAME_EMPTY")
	});

	$("#meeting_manager").formValidator({
		relativeID: "manager_wrap",
		onFocus: Ibos.l("MEETING.SELECT_ROOM_ADMIN")
	})
	.regexValidator({
		regExp: "notempty",
		dataType: "enum",
		onError: Ibos.l("MEETING.ROOM_ADMIN_EMPTY")
	})
	.on("change", function(){ $(this).trigger("blur"); });

	$("#capacity").formValidator()
	.regexValidator({
		regExp: "intege1",
		dataType: "enum",
		onError: Ibos.l("MEETING.INPUT_RIGHT_SEAT_NUM")
	});

	$("input[name='applyday[]']").formValidator({
		relativeID: "cycle_group_wrap",
		onFocus: Ibos.l("MEETING.SELECT_APPLY_PERIOD")
	}).functionValidator({
		fun: function(txt, elem){
			var val = U.getCheckedValue("applyday[]");
			return  val.length ? true : Ibos.l("MEETING.APPLY_PERIOD_EMPTY");
		},
		onError: Ibos.l("MEETING.APPLY_PERIOD_EMPTY")
	});

	Ibos.evt.add({
	// 申请日期
        "applyDay": function(param, elem){
            var $this = $(this),
                $checkbox = $this.find("input:checkbox"),
                isChecked = $checkbox.prop("checked");
    		$this.toggleClass("active");
            $checkbox.prop("checked", !isChecked);   
        },
        // 选择所有设备
        "selectAllEquiptment": function(param, elem){
        	var $this = $(this),
        		$li = $("#equipment_list li"),
        		$checkboxs = $li.find("input:checkbox"),
    			isChecked = $this.prop("checked");
    		$li[isChecked ? "addClass" : "removeClass"]("active");
    		$checkboxs.prop("checked", isChecked);
        },
        // 选择设备
        "selectEquipment": function(param, elem){
        	var $this = $(this),
        		$checkbox = $this.find("input[type='checkbox']"),
        		isChecked = $checkbox.prop("checked");
    		$this.toggleClass("active");
        	$checkbox.prop("checked", !isChecked);
        }
    });
});