Ibos.events.add({
    /**
     * 恢复工作
     * @param {object} $elem
     * @param {mixed} param
     * @returns {undefined}
     */
    'restoreRun': function(param, $elem) {
        wfList.batchOpt(Ibos.app.url('workflow/recycle/restore'), null, function(res, ids) {
            wfList.removeRows(ids);
        }, Ibos.l('WF.CONFIRM_RESTORE_RUN'));
    },
    /**
     * 销毁工作
     * @param {object} $elem
     * @param {mixed} param
     * @returns {undefined}
     */
    'destroy': function(param, $elem) {
        wfList.batchOpt(Ibos.app.url('workflow/recycle/destroy'), null, function(res, ids) {
            wfList.removeRows(ids);
        }, Ibos.l('WF.CONFIRM_DESTROY_RUN'));
    }
});

(function() {
    var _ajax = function(url, param, success, msg) {
        if (!url) {
            console.error('should have post url');
        }
        Ui.confirm(msg, function() {
            $.post(url, param, function(res) {
                if (res.isSuccess) {
                    success.call(null, res, param.id + '');
                } else {
                    Ui.tip(res.msg, 'warning');
                }
            }, 'json');
        });
    }

    Ibos.evt.add({
        'destroyUnit': function(param, elem) {
            _ajax(Ibos.app.url('workflow/recycle/destroy'), { id: param }, function(res, ids) {
                wfList.removeRows(ids);
            }, Ibos.l('WF.CONFIRM_DESTROY_RUN'));
        },
        'restoreUnit': function(param, elem) {
            _ajax(Ibos.app.url('workflow/recycle/restore'), { id: param }, function(res, ids) {
                wfList.removeRows(ids);
            }, Ibos.l('WF.CONFIRM_RESTORE_RUN'));
        }
    });
})();
