$(function() {
    var workFlowSetting = {
        init: function() {
            $("#flow_edit_tab li:has('.active') a").tab("show");
            $(".checkbox input[type='checkbox'], .radio input[type='radio']").label();
            $("[data-toggle='tooltip']").tooltip();

            this.signOptions();
            this.operatorAllow();
            this.automaticRule();
            this.pluginsSelect();
            this.subFlow();
        },
        // 会签选项
        signOptions: function() {
            $("#sign_options").on("change", function() {
                $("#sign_visibility").toggle(this.value === "0" || this.value === "2");
            });
        },
        // 步骤经办人权限
        operatorAllow: function() {
            var write = $('#write'),
                secret = $('#secret'),
                check = $('#check');

            var formCheck = {
                $writeSelector: $("input[name='write[]']"),
                $secretSelector: $("input[name='secret[]']"),
                $checkSelector: $("input[name='check[]']"),
                $microSelector: $("input[name='micro[]']"),
                writeCheck: function($obj) {
                    var id = $obj.data('id'),
                        isChecked = $obj.prop('checked');
                    if ($obj.prop('disabled') !== true) {
                        $('#secret_' + id).prop('disabled', isChecked);
                        $('#regex_' + id).prop('disabled', !isChecked).prop('checked', false);
                        $('#regexList_' + id).prop('disabled', true).hide();

                        if (isChecked) {
                            $('#micro_' + id).prop('checked', false).prop('disabled', false).parent().css('color', '#000');
                        } else {
                            $('#micro_' + id).prop('checked', false).prop('disabled', true).parent().css('color', '#a0a0a0');
                        }
                    }
                },
                ruleCheck: function($obj) {
                    var id = $obj.data('id'),
                        isChecked = $obj.prop('checked');
                    if ($obj.prop('disabled') !== true) {
                        if (isChecked) {
                            $('#regexList_' + id).prop('disabled', false).show();
                        } else {
                            $('#regexList_' + id).prop('disabled', true).hide();
                        }
                    }
                },
                secretCheck: function($obj) {
                    var id = $obj.data('id'),
                        isChecked = $obj.prop('checked');
                    if ($obj.prop('disabled') !== true) {
                        if (isChecked) {
                            $('#write_' + id).prop('disabled', true).prop('checked', false);
                        } else {
                            $('#write_' + id).prop('disabled', false).prop('checked', false);
                        }
                    }
                },
                checkAll: function(type, checked) {
                    var that = this;
                    switch (type) {
                        case 'write':
                            that.$writeSelector.each(function() {
                                if ($(this).prop('disabled') !== true) {
                                    $(this).prop('checked', checked);
                                }
                                that.writeCheck($(this));
                            });
                            break;
                        case 'secret':
                            that.$secretSelector.each(function() {
                                if ($(this).prop('disabled') !== true) {
                                    $(this).prop('checked', checked);
                                }
                                that.secretCheck($(this));
                            });
                            break;
                        case 'check':
                            that.$checkSelector.each(function() {
                                if ($(this).prop('disabled') !== true) {
                                    $(this).prop('checked', checked);
                                }
                                that.ruleCheck($(this));
                            });
                            break;
                        case 'micro':
                            that.$microSelector.each(function() {
                                if ($(this).prop('disabled') !== true) {
                                    $(this).prop('checked', checked);
                                }
                            });
                            break;
                    }
                }
            };

            $("#operator_allow").userSelect({
                data: Ibos.data.get(),
                type: "all"
            });

            $("#step_form_field").on("change", "input[type='checkbox']", function() {
                var elemId = this.id,
                    values = elemId.split("_", 2),
                    type = values[0], // 
                    id = values[1],
                    isChecked = this.checked;

                if (id) {
                    switch (type) {
                        case "write":
                            formCheck.writeCheck($(this));
                            write.prop('disabled', false);
                            if (write.prop('checked') == true) {
                                write.prop('checked', false);
                            };
                            break;
                        case "secret":
                            formCheck.secretCheck($(this));
                            secret.prop('disabled', false);
                            if (secret.prop('checked') == true) {
                                secret.prop('checked', false)
                            };
                            break;
                        case "regex":
                            formCheck.ruleCheck($(this));
                            check.prop('disabled', false);
                            if (check.prop('checked') == true) {
                                check.prop('checked', false);
                            };
                            break;
                        case "micro":
                            check.prop('disabled', false);
                            if (check.prop('checked') == true) {
                                check.prop('checked', false);
                            };
                            break;
                        default:
                            break;
                    }
                } else {
                    switch (elemId) {
                        case "write":
                            formCheck.checkAll('write', isChecked);
                            secret.prop('checked', false).prop('disabled', isChecked);
                            check.prop('checked', false).prop('disabled', !isChecked);
                            break;
                        case "secret":
                            formCheck.checkAll('secret', isChecked);
                            write.prop('disabled', isChecked).prop('checked', false);
                            break;
                        case "check":
                            formCheck.checkAll('check', isChecked);
                            formCheck.checkAll('micro', isChecked);
                            break;
                        default:
                            break;
                    }
                }
            });
        },
        // 自动选人规则
        automaticRule: function() {
            var assign_user = $("#assign_user"),
                form_field = $("#form_field"),
                assign_step = $("#assign_step"),
                dept_for = $("#dept_for"),
                form_field_select = $("#form_field_select"),
                rule = {
                    user: function() {
                        assign_user.show().siblings().hide();
                    },
                    field: function() {
                        if (form_field_select.html() == '') {
                            var formItemUrl = Ibos.app.url('workflow/api/getitem'),
                                param = {
                                    flowid: Ibos.app.g("flowid")
                                };
                            $.get(formItemUrl, param, function(res) {
                                if (res.isSuccess) {
                                    var options = "",
                                        autotype = Ibos.app.g("autotype"),
                                        autouser = Ibos.app.g("autouser");
                                    $.each(res.data, function(i, n) {
                                        options += "<option value='" + i + "'>" + n + "</option>";
                                    });
                                    form_field_select.html(options);
                                    if (autotype == "7") {
                                        console.log(autouser);
                                        form_field_select.find("option[value=" + (autouser ? +autouser.replace(/\D*/g, "") : '') + "]").attr("selected", "selected");
                                    }
                                }
                            }, 'json');
                        }
                        form_field.show().siblings().hide();
                    },
                    step: function() {
                        assign_step.show().siblings().hide();
                    },
                    dept: function() {
                        dept_for.show().siblings().hide();
                    },
                    none: function() {
                        $("#assign_user, #form_field, #assign_step, #dept_for").hide();
                    }
                };

            $('#operator_automatic').on("change", function() {
                var value = this.value;
                switch (value) {
                    case "2":
                    case "4":
                    case "6":
                    case "9":
                        // 部门对象针对
                        rule.dept();
                        break;
                    case "3":
                        // 人员指定
                        rule.user();
                        break;
                    case "7":
                        // 表单字段指定
                        rule.field();
                        break;
                    case "8":
                        // 步骤指定
                        rule.step();
                        break;
                    default:
                        // 其它
                        rule.none();
                        break;
                }
            });

            $("#force_forward, #rollback,#allowed_change, #allow_limit, #sign_forward").iSwitch();
        },

        pluginsSelect: function() {
            // 插件选择
            $("#select_save_plugin, #select_forward_plugin").click(function() {
                Ui.dialog({
                    id: "d_plugin_dialog",
                    title: Ibos.l("WF.PLUGIN_SELECT"),
                    content: Ibos.l("WF.NO_PLUGIN_AVAILABLE"),
                    cancel: true,
                    cancelVal: Ibos.l("CLOSE"),
                    width: 300
                });
            });

            // 表单条件选择器
            $("#step_condition").on("click", "[data-condition]", function() {
                var id = $.attr(this, 'data-id'),
                    type = $.attr(this, "data-condition"),
                    $conditionLogic = $("#condition_logic_" + id),
                    $conditionLogicInput = $("#condition_logic_input_" + id),
                    formCondition = new FormCondition(document.getElementById("condition_select_" + id));

                $conditionLogicInput.val($conditionLogic.find('button.active').attr('data-value'));
                var logic = $conditionLogicInput.val();

                $conditionLogic.on("click", "button", function() {
                    var value = $.attr(this, "data-value");
                    $conditionLogicInput.val(value);
                    logic = value;
                });

                if (type === "addCondition") {
                    var field = $("#condition_field_" + id).val(),
                        operator = $("#condition_operator_" + id).val(),
                        value = $("#condition_value_" + id).val();
                    formCondition.addCondition(field, operator, value, logic);
                } else {
                    formCondition[type](logic);
                }
                $("#condition_result_" + id).val(formCondition.getConditions());
            });
        },
        // 子流程
        subFlow: function() {
            // 切换节点类型
            $("#node_type").on("change", function() {
                var isStepNode = (this.value === "0"),
                    $step = $("#node_type_step"),
                    $subflow = $("#node_type_subflow");

                $step.toggle(isStepNode);
                $subflow.toggle(!isStepNode);
                // 子流程只能配置基本信息
                $('#flow_edit_tab').find('li:first').siblings('li').toggle(isStepNode);
            }).trigger('change');

            // 子流程返回步骤主办人
            $("#subflow_return_sponsor").userSelect({
                data: Ibos.data.get("user"),
                type: "user",
                maximumSelectionSize: 1
            });

            // 子流程返回步骤经办人
            $("#subflow_return_handler").userSelect({
                data: Ibos.data.get("user"),
                type: "user"
            });

            // 子流程类型
            // 对应关系
            var $subflowType = $("#subflow_type"),
                $parentFlowSelect = $("#subflow_parent_field"),
                $childFlowSelect = $("#subflow_child_field"),
                $relativeBtn = $("#subflow_relative_btn"),
                $mapList = $("#field_map_list"),

                refreshRelativeBtnStatus = function() {
                    var parentFlowValue = $parentFlowSelect.val(),
                        childFlowValue = $childFlowSelect.val();

                    $relativeBtn.prop("disabled", !(parentFlowValue && childFlowValue));
                },

                fieldMatchUp = {
                    $container: $mapList,
                    $input: $("#field_map_value"),
                    tpl: "<li data-value='<%=id%>'><%=parent%>=&gt;<%=child%><a href='javascript:;' class='close' data-type='removeMap' data-id=<%=id%>>x</a></li>",
                    refreshValue: function() {
                        var val = "",
                            $items = this.$container.find("li"),
                            rel;

                        val = $items.map(function($item) {
                            return $.attr(this, "data-value").replace("_", "=>")
                        }).get().join(",");

                        this.$input.val(val);
                    },
                    add: function(parent, child) {
                        var id = parent + "_" + child;
                        if (this.$container.find("li[data-value='" + id + "']").length) {
                            Ui.tip(Ibos.l("WF.EXISTING_CORRESPONDENCE"), "warning");
                            return;
                        }

                        $.tmpl(this.tpl, { id: id, parent: parent, child: child }).appendTo(this.$container);
                        this.refreshValue();
                    },
                    remove: function(id) {
                        this.$container.find("li[data-value='" + id + "']").remove();
                        this.refreshValue();
                    },
                    clear: function() {
                        this.$container.empty();
                        this.refreshValue();
                    }
                };

            $subflowType.on("change", function(evt, data) {
                var val = this.value;
                data = data || {};
                $.get(Ibos.app.url("workflow/api/getField"), { flowid: val }, function(res) {
                    if (res.isSuccess) {
                        var options = "";
                        for (var i = 0; i < res.data.length; i++) {
                            options += "<option value='" + res.data[i] + "'>" + res.data[i] + "</option>";
                        }
                        $childFlowSelect.html(options);
                        refreshRelativeBtnStatus();
                        // 除了初始化时的change事件，改变子流程类型时，清空映射关系
                        if (!data.init) {
                            fieldMatchUp.clear();
                        }
                    }
                }, 'json');
            });

            $parentFlowSelect.on("change", refreshRelativeBtnStatus);
            $childFlowSelect.on("change", refreshRelativeBtnStatus);

            $relativeBtn.on("click", function() {
                fieldMatchUp.add($parentFlowSelect.val(), $childFlowSelect.val());
            });
            $mapList.on("click", "[data-type='removeMap']", function() {
                fieldMatchUp.remove($.attr(this, "data-id"));
            });
            // 子流程返回结果交互
            $("[data-act='overAct']").on('change', function() {
                $('#subflow_prcs_back').toggle(this.value === '1');
            });
        }
    };

    workFlowSetting.init();
    /**
     * 超时设置
     */
    Ibos.evt.add({
        "timeSetting": function(param, elem) {
            var $this = $(elem),
                time = param.value,
                menu = $this.closest(".dropdown-menu"),
                parent = $this.parent(),
                text_con = $("#setting_timelimit"),
                timeunit = $("input[name=timeunit]");
            // 样式修改
            menu.children("li").removeClass("active");
            parent.addClass("active");
            // 单位值修改
            switch (time) {
                case "mins":
                    text_con.text("分");
                    break;
                case "hours":
                    text_con.text("小时");
                    break;
                case "days":
                    text_con.text("天");
                    break;
                case "weeks":
                    text_con.text("周");
                    break;
                default:
                    break;
            }
            timeunit.val(time);
        }
    });
});
//@ sourceURL=workflow_process.js
