<?php

use application\core\utils\Cache;
use application\core\utils\Ibos;
use application\modules\dashboard\model\Menu;
use application\modules\dashboard\model\Nav;
use application\modules\main\model\MenuCommon;
use application\modules\main\model\Setting;
use application\modules\message\model\Notify;
use application\modules\message\model\NotifyMessage;
use application\modules\role\model\AuthItem;
use application\modules\role\model\AuthItemChild;
use application\modules\role\model\Node;
use application\modules\role\model\NodeRelated;

// 删除导航
Nav::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
// 删除消息节点与站内提醒记录
Notify::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
NotifyMessage::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
Cache::set( 'notifyNode', null );
Node::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
NodeRelated::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
// step3:删除授权信息
AuthItem::model()->deleteAll( "name LIKE 'workflow%'" );
AuthItemChild::model()->deleteAll( "child LIKE 'workflow%'" );
// 删除常用菜单
MenuCommon::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );

// 删除setting键值
$settingFields = 'wfremindbefore,wfremindafter,sealfrom';
Setting::model()->deleteAll( "FIND_IN_SET(skey,'{$settingFields}')" );
// 后台菜单
Menu::model()->deleteAllByAttributes( array( 'm' => 'workflow' ) );
// 导航
Nav::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
// 删除授权节点
Node::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
NodeRelated::model()->deleteAllByAttributes( array( 'module' => 'workflow' ) );
AuthItem::model()->deleteAll( "name LIKE 'workflow%'" );
AuthItemChild::model()->deleteAll( "child LIKE 'workflow%'" );
// 删除所有相关数据表
$db = Ibos::app()->db->createCommand();
$prefix = $db->getConnection()->tablePrefix;
$tables = $db->setText( "SHOW TABLES LIKE '" . str_replace( '_', '\_', $prefix . 'flow_data_%' ) . "'" )
		->queryAll( false );
foreach ( $tables as $table ) {
	$tableName = $table[0];
	!empty( $tableName ) && $db->dropTable( $tableName );
}
